package dev.shadowsoffire.apotheosis.adventure.client;

import net.minecraft.Util;
import com.mojang.blaze3d.vertex.VertexFormat;
import net.minecraft.client.renderer.RenderStateShard;
import dev.shadowsoffire.apotheosis.adventure.socket.gem.Gem;
import dev.shadowsoffire.apotheosis.adventure.loot.LootRarity;
import dev.shadowsoffire.apotheosis.adventure.socket.gem.GemItem;
import net.minecraft.world.entity.LivingEntity;
import net.minecraft.client.multiplayer.ClientLevel;
import net.minecraft.client.renderer.item.ItemProperties;
import net.minecraft.world.item.Item;
import net.minecraftforge.fml.event.lifecycle.FMLClientSetupEvent;
import net.minecraftforge.client.event.RegisterKeyMappingsEvent;
import java.io.IOException;
import net.minecraft.client.renderer.ShaderInstance;
import com.mojang.blaze3d.vertex.DefaultVertexFormat;
import net.minecraftforge.client.event.RegisterShadersEvent;
import net.minecraft.client.resources.model.BakedModel;
import net.minecraft.client.resources.model.ModelResourceLocation;
import dev.shadowsoffire.apotheosis.Apotheosis;
import java.util.Set;
import net.minecraftforge.client.event.RegisterClientTooltipComponentFactoriesEvent;
import net.minecraftforge.client.event.ModelEvent;
import net.minecraftforge.api.distmarker.Dist;
import net.minecraftforge.fml.common.Mod;
import dev.shadowsoffire.apotheosis.adventure.affix.reforging.ReforgingTableTileRenderer;
import dev.shadowsoffire.apotheosis.adventure.affix.augmenting.AugmentingTableTileRenderer;
import net.minecraft.client.renderer.blockentity.BlockEntityRenderer;
import net.minecraft.client.renderer.blockentity.BlockEntityRendererProvider;
import net.minecraft.network.chat.MutableComponent;
import dev.shadowsoffire.apotheosis.adventure.AdventureModule;
import net.minecraft.client.resources.language.I18n;
import dev.shadowsoffire.placebo.codec.CodecProvider;
import dev.shadowsoffire.apotheosis.adventure.affix.AffixRegistry;
import net.minecraft.client.renderer.RenderType;
import net.minecraft.resources.ResourceLocation;
import dev.shadowsoffire.placebo.reload.DynamicHolder;
import java.util.Map;
import java.util.Collection;
import java.util.function.Function;
import dev.shadowsoffire.apotheosis.adventure.affix.AffixInstance;
import java.util.Comparator;
import dev.shadowsoffire.apotheosis.adventure.affix.Affix;
import net.minecraft.ChatFormatting;
import java.util.ArrayList;
import dev.shadowsoffire.apotheosis.adventure.affix.AffixHelper;
import net.minecraftforge.event.entity.player.ItemTooltipEvent;
import net.minecraft.network.chat.ComponentContents;
import java.util.Optional;
import net.minecraft.world.inventory.tooltip.TooltipComponent;
import net.minecraft.network.chat.FormattedText;
import net.minecraft.network.chat.contents.LiteralContents;
import com.mojang.datafixers.util.Either;
import net.minecraftforge.client.event.RenderTooltipEvent;
import java.util.function.Consumer;
import java.util.Objects;
import dev.shadowsoffire.apotheosis.adventure.socket.gem.GemInstance;
import dev.shadowsoffire.attributeslib.api.client.GatherSkippedAttributeTooltipsEvent;
import net.minecraftforge.eventbus.api.EventPriority;
import java.util.ListIterator;
import net.minecraft.world.item.ItemStack;
import net.minecraft.network.chat.Component;
import dev.shadowsoffire.apotheosis.adventure.socket.SocketHelper;
import dev.shadowsoffire.attributeslib.api.client.AddAttributeTooltipsEvent;
import net.minecraftforge.event.TickEvent;
import net.minecraftforge.eventbus.api.SubscribeEvent;
import net.minecraft.world.phys.Vec3;
import net.minecraft.world.entity.player.Player;
import com.mojang.blaze3d.vertex.PoseStack;
import net.minecraft.client.renderer.blockentity.BeaconRenderer;
import net.minecraft.client.renderer.MultiBufferSource;
import com.mojang.blaze3d.vertex.Tesselator;
import net.minecraftforge.client.event.RenderLevelStageEvent;
import java.util.Iterator;
import net.minecraft.client.sounds.SoundManager;
import net.minecraft.client.resources.sounds.SoundInstance;
import net.minecraft.client.resources.sounds.SimpleSoundInstance;
import net.minecraft.sounds.SoundSource;
import net.minecraft.sounds.SoundEvent;
import dev.shadowsoffire.apotheosis.adventure.AdventureConfig;
import net.minecraft.client.Minecraft;
import org.apache.commons.lang3.mutable.MutableInt;
import net.minecraft.core.BlockPos;
import net.minecraft.client.renderer.blockentity.BlockEntityRenderers;
import dev.shadowsoffire.apotheosis.Apoth;
import net.minecraft.world.level.block.entity.BlockEntityType;
import dev.shadowsoffire.apotheosis.adventure.affix.augmenting.AugmentingScreen;
import dev.shadowsoffire.apotheosis.adventure.socket.gem.cutting.GemCuttingScreen;
import dev.shadowsoffire.apotheosis.adventure.affix.salvaging.SalvagingScreen;
import net.minecraft.client.gui.screens.MenuScreens;
import dev.shadowsoffire.apotheosis.adventure.affix.reforging.ReforgingScreen;
import dev.shadowsoffire.apotheosis.adventure.Adventure;
import net.minecraft.world.inventory.MenuType;
import net.minecraftforge.common.MinecraftForge;
import java.util.List;

public class AdventureModuleClient
{
    public static List<BossSpawnMessage.BossSpawnData> BOSS_SPAWNS;
    
    public static void init() {
        MinecraftForge.EVENT_BUS.register((Object)AdventureModuleClient.class);
        MenuScreens.m_96206_((MenuType)Adventure.Menus.REFORGING.get(), ReforgingScreen::new);
        MenuScreens.m_96206_((MenuType)Adventure.Menus.SALVAGE.get(), SalvagingScreen::new);
        MenuScreens.m_96206_((MenuType)Adventure.Menus.GEM_CUTTING.get(), GemCuttingScreen::new);
        MenuScreens.m_96206_((MenuType)Adventure.Menus.AUGMENTING.get(), AugmentingScreen::new);
        BlockEntityRenderers.m_173590_((BlockEntityType)Apoth.Tiles.REFORGING_TABLE.get(), k -> new ReforgingTableTileRenderer());
        BlockEntityRenderers.m_173590_((BlockEntityType)Apoth.Tiles.AUGMENTING_TABLE.get(), k -> new AugmentingTableTileRenderer());
        MinecraftForge.EVENT_BUS.register((Object)AdventureKeys.class);
    }
    
    public static void onBossSpawn(final BlockPos pos, final float[] color) {
        AdventureModuleClient.BOSS_SPAWNS.add(new BossSpawnMessage.BossSpawnData(pos, color, new MutableInt()));
        final SoundManager sm = Minecraft.m_91087_().m_91106_();
        for (final SoundEvent soundEvent : AdventureConfig.bossAnnounceSounds) {
            sm.m_120367_((SoundInstance)new SimpleSoundInstance(soundEvent, SoundSource.HOSTILE, AdventureConfig.bossAnnounceVolume, 1.25f, Minecraft.m_91087_().f_91074_.m_217043_(), Minecraft.m_91087_().f_91074_.m_20183_()));
        }
    }
    
    @SubscribeEvent
    public static void render(final RenderLevelStageEvent e) {
        if (e.getStage() != RenderLevelStageEvent.Stage.AFTER_TRIPWIRE_BLOCKS) {
            return;
        }
        final PoseStack stack = e.getPoseStack();
        final MultiBufferSource.BufferSource buf = MultiBufferSource.m_109898_(Tesselator.m_85913_().m_85915_());
        final Player p = (Player)Minecraft.m_91087_().f_91074_;
        for (int i = 0; i < AdventureModuleClient.BOSS_SPAWNS.size(); ++i) {
            final BossSpawnMessage.BossSpawnData data = AdventureModuleClient.BOSS_SPAWNS.get(i);
            stack.m_85836_();
            final float partials = e.getPartialTick();
            final Vec3 vec = Minecraft.m_91087_().m_91288_().m_20299_(partials);
            stack.m_85837_(-vec.f_82479_, -vec.f_82480_, -vec.f_82481_);
            stack.m_252880_((float)data.pos().m_123341_(), (float)data.pos().m_123342_(), (float)data.pos().m_123343_());
            BeaconRenderer.m_112184_(stack, (MultiBufferSource)buf, BeaconRenderer.f_112102_, partials, 1.0f, p.m_9236_().m_46467_(), 0, 64, data.color(), 0.166f, 0.33f);
            stack.m_85849_();
        }
        buf.m_109911_();
    }
    
    @SubscribeEvent
    public static void time(final TickEvent.ClientTickEvent e) {
        if (e.phase != TickEvent.Phase.END) {
            return;
        }
        for (int i = 0; i < AdventureModuleClient.BOSS_SPAWNS.size(); ++i) {
            final BossSpawnMessage.BossSpawnData data = AdventureModuleClient.BOSS_SPAWNS.get(i);
            if (data.ticks().getAndIncrement() > 400) {
                AdventureModuleClient.BOSS_SPAWNS.remove(i--);
            }
        }
    }
    
    @SubscribeEvent(priority = EventPriority.HIGH)
    public static void tooltips(final AddAttributeTooltipsEvent e) {
        final ItemStack stack = e.getStack();
        final ListIterator<Component> it = e.getAttributeTooltipIterator();
        final int sockets = SocketHelper.getSockets(stack);
        if (sockets > 0) {
            it.add((Component)Component.m_237113_("APOTH_REMOVE_MARKER"));
        }
    }
    
    @SubscribeEvent
    public static void ignoreSocketUUIDS(final GatherSkippedAttributeTooltipsEvent e) {
        final ItemStack stack = e.getStack();
        for (final GemInstance gem : SocketHelper.getGems(stack)) {
            final List uuiDs = gem.getUUIDs();
            Objects.requireNonNull(e);
            uuiDs.forEach(e::skipUUID);
        }
    }
    
    @SubscribeEvent
    public static void comps(final RenderTooltipEvent.GatherComponents e) {
        final int sockets = SocketHelper.getSockets(e.getItemStack());
        if (sockets == 0) {
            return;
        }
        final List<Either<FormattedText, TooltipComponent>> list = e.getTooltipElements();
        int rmvIdx = -1;
        for (int i = 0; i < list.size(); ++i) {
            final Optional<FormattedText> o = list.get(i).left();
            if (o.isPresent()) {
                final FormattedText value = o.get();
                if (value instanceof final Component comp) {
                    final ComponentContents 214077_ = comp.m_214077_();
                    if (214077_ instanceof final LiteralContents tc) {
                        if ("APOTH_REMOVE_MARKER".equals(tc.f_237368_())) {
                            rmvIdx = i;
                            list.remove(i);
                            break;
                        }
                    }
                }
            }
        }
        if (rmvIdx == -1) {
            return;
        }
        e.getTooltipElements().add(rmvIdx, Either.right((Object)new SocketTooltipRenderer.SocketComponent(e.getItemStack(), SocketHelper.getGems(e.getItemStack()))));
    }
    
    @SubscribeEvent(priority = EventPriority.HIGH)
    public static void affixTooltips(final ItemTooltipEvent e) {
        final ItemStack stack = e.getItemStack();
        if (stack.m_41782_()) {
            final Map<DynamicHolder<? extends Affix>, AffixInstance> affixes = AffixHelper.getAffixes(stack);
            final List<Component> components = new ArrayList<Component>();
            final Consumer<Component> dotPrefixer = afxComp -> components.add(Component.m_237110_("text.apotheosis.dot_prefix", new Object[] { afxComp }).m_130940_(ChatFormatting.YELLOW));
            affixes.values().stream().sorted(Comparator.comparingInt(a -> ((Affix)a.affix().get()).getType().ordinal())).map((Function<? super AffixInstance, ?>)AffixInstance::getDescription).filter(c -> c.m_214077_() != ComponentContents.f_237124_).forEach((Consumer<? super Object>)dotPrefixer);
            e.getToolTip().addAll(1, components);
        }
    }
    
    public static RenderType gray(final ResourceLocation texture) {
        return CustomRenderTypes.GRAY.apply(texture);
    }
    
    public static void checkAffixLangKeys() {
        final StringBuilder sb = new StringBuilder("Missing Affix Lang Keys:\n");
        boolean any = false;
        final String json = "\"%s\": \"\",";
        for (Affix a : AffixRegistry.INSTANCE.getValues()) {
            final ResourceLocation id = AffixRegistry.INSTANCE.getKey((CodecProvider)a);
            if (!I18n.m_118936_("affix." + id)) {
                sb.append(json.formatted("affix." + id));
                any = true;
            }
            if (!I18n.m_118936_("affix." + id + ".suffix")) {
                sb.append(json.formatted("affix." + id + ".suffix"));
                any = true;
            }
        }
        if (any) {
            AdventureModule.LOGGER.error(sb.toString());
        }
    }
    
    static {
        AdventureModuleClient.BOSS_SPAWNS = new ArrayList<BossSpawnMessage.BossSpawnData>();
    }
    
    @Mod.EventBusSubscriber(modid = "apotheosis", value = { Dist.CLIENT }, bus = Mod.EventBusSubscriber.Bus.MOD)
    public static class ModBusSub
    {
        @SubscribeEvent
        public static void models(final ModelEvent.RegisterAdditional e) {
            e.register(ReforgingTableTileRenderer.HAMMER);
            e.register(AugmentingTableTileRenderer.STAR_CUBE);
        }
        
        @SubscribeEvent
        public static void tooltipComps(final RegisterClientTooltipComponentFactoriesEvent e) {
            e.register((Class)SocketTooltipRenderer.SocketComponent.class, (Function)SocketTooltipRenderer::new);
        }
        
        @SubscribeEvent
        public static void addGemModels(final ModelEvent.RegisterAdditional e) {
            final Set<ResourceLocation> locs = Minecraft.m_91087_().m_91098_().m_214159_("models", loc -> "apotheosis".equals(loc.m_135827_()) && loc.m_135815_().contains("/gems/") && loc.m_135815_().endsWith(".json")).keySet();
            for (final ResourceLocation s : locs) {
                final String path = s.m_135815_().substring("models/".length(), s.m_135815_().length() - ".json".length());
                e.register(new ResourceLocation("apotheosis", path));
            }
        }
        
        @SubscribeEvent
        public static void replaceGemModel(final ModelEvent.ModifyBakingResult e) {
            final ModelResourceLocation key = new ModelResourceLocation(Apotheosis.loc("gem"), "inventory");
            final BakedModel oldModel = e.getModels().get(key);
            if (oldModel != null) {
                e.getModels().put(key, new GemModel(oldModel, e.getModelBakery()));
            }
        }
        
        @SubscribeEvent
        public static void shaderRegistry(final RegisterShadersEvent event) throws IOException {
            event.registerShader(new ShaderInstance(event.getResourceProvider(), new ResourceLocation("apotheosis:gray"), DefaultVertexFormat.f_85812_), shaderInstance -> CustomRenderTypes.grayShader = shaderInstance);
        }
        
        @SubscribeEvent
        public static void keys(final RegisterKeyMappingsEvent e) {
            e.register(AdventureKeys.TOGGLE_RADIAL);
        }
        
        @SubscribeEvent
        public static void client(final FMLClientSetupEvent e) {
            if (Apotheosis.enableAdventure) {
                e.enqueueWork(() -> ItemProperties.register((Item)Adventure.Items.GEM.get(), Apotheosis.loc("rarity"), (stack, level, entity, tint) -> {
                    final DynamicHolder<Gem> gem = (DynamicHolder<Gem>)GemItem.getGem(stack);
                    final DynamicHolder<LootRarity> rarity = (DynamicHolder<LootRarity>)AffixHelper.getRarity(stack);
                    return (gem.isBound() && rarity.isBound()) ? ((float)((LootRarity)rarity.get()).ordinal()) : Float.NEGATIVE_INFINITY;
                }));
            }
        }
    }
    
    private static class CustomRenderTypes extends RenderType
    {
        private static ShaderInstance grayShader;
        private static final RenderStateShard.ShaderStateShard RENDER_TYPE_GRAY;
        public static Function<ResourceLocation, RenderType> GRAY;
        
        private static RenderType gray(final ResourceLocation loc) {
            final RenderType.CompositeState rendertype$state = RenderType.CompositeState.m_110628_().m_173292_(CustomRenderTypes.RENDER_TYPE_GRAY).m_173290_((RenderStateShard.EmptyTextureStateShard)new RenderStateShard.TextureStateShard(loc, false, false)).m_110685_(CustomRenderTypes.f_110139_).m_110675_(CustomRenderTypes.f_110129_).m_110671_(CustomRenderTypes.f_110152_).m_110677_(CustomRenderTypes.f_110154_).m_110687_(RenderStateShard.f_110114_).m_110691_(true);
            return (RenderType)m_173215_("gray", DefaultVertexFormat.f_85812_, VertexFormat.Mode.QUADS, 256, true, false, rendertype$state);
        }
        
        private CustomRenderTypes(final String s, final VertexFormat v, final VertexFormat.Mode m, final int i, final boolean b, final boolean b2, final Runnable r, final Runnable r2) {
            super(s, v, m, i, b, b2, r, r2);
            throw new IllegalStateException("This class is not meant to be constructed!");
        }
        
        static {
            RENDER_TYPE_GRAY = new RenderStateShard.ShaderStateShard(() -> CustomRenderTypes.grayShader);
            CustomRenderTypes.GRAY = Util.m_143827_((Function)CustomRenderTypes::gray);
        }
    }
}
